/*
** Weekday v1.0
**
** Calculates weekday from date
**
** Copyright (c) 14.6.94 by Andreas Ley <ley@rz.uni-karlsruhe.de>
**
** Permission to use, copy, modify, and distribute this software for any
** purpose and without fee is hereby granted, provided that the above
** copyright notice appears in all copies. This software is provided "as is"
** and without any express or implied warranties.
**
** This program has been tested on a HP9000/720 with HP-UX A.08.07
** In this environment, neither lint -u nor gcc -Wall produce any messages.
** If you encounter any errors or need to make any changes to port it
** to another platform, please contact me.
**
** Version history
**
** Version 1.0 - 14.6.94
**	Initial version
*/

char header[]="weekday v1.0\n(c) 1994 by Andreas Ley\n";

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

char	*weekday[]={"Sonntag", "Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag"};


void usage(char *image)
{
	(void)fprintf(stderr,"Usage: %s [-h] [-v] [yy]yy mm dd\n",image);
	exit(1);
}


int main(int argc, char *argv[])
{
	int		c,year;
	extern int	optind;
	time_t		tloc;
	struct tm	*timeptr;

	while ((c=getopt(argc,argv,"vh?")) != EOF)
		switch ((char)c) {
		case 'v':
			(void)fprintf(stderr,header);
			exit(0);
		case 'h':
			(void)fprintf(stderr,header);
		case '?':
			usage(argv[0]);
		}
	if (optind+3!=argc)
		usage(argv[0]);

	tloc=time((time_t *)NULL);
	timeptr=localtime(&tloc);

	year=atoi(argv[optind++]);
	timeptr->tm_year=year<100?year:year-1900;
	timeptr->tm_mon=atoi(argv[optind++])-1;
	timeptr->tm_mday=atoi(argv[optind]);

	tloc=mktime(timeptr);
	timeptr=localtime(&tloc);
	(void)printf("%s\n",weekday[timeptr->tm_wday]);

	return(0);
}
